%{
#include <stdio.h>
#include <stdlib.h>
#include "mytree.h"
%}

%union {

	int a_number;
	char a_variable;
	tree* a_tree;
}

%start input
%token <a_number> number
%token <a_variable> variable
%type <a_tree> exp term factor

%%
input  : exp ';'               {printtree ($1, 1);}
    ;
exp    : '+' term              {$$ = $2;}
    | '-' term              {$$ = make_operator (NULL, '~', $2);}
    | term                  {$$ = $1;}
    | exp '+' term          {$$ = make_operator ($1, '+', $3);}
    | exp '-' term          {$$ = make_operator ($1, '-', $3);}
    ;
term   : factor                {$$ = $1;}
    | term '*' factor       {$$ = make_operator ($1, '*', $3);}
    | term '/' factor       {$$ = make_operator ($1, '/', $3);}
    ;
factor : number                {$$ = make_number ($1);}
    | variable              {$$ = make_variable ($1);}
    | '(' exp ')'           {$$ = $2;}
    ;
%%

void yyerror (char *s) {
	fprintf (stderr, "%s\n", s);
}

int main (void) {
	return yyparse();
}

